///////////////////////////////////////////////
// Titre : Editor                            //
// Auteur : lalilo                           //
// Date : 2005                               //
// Description : Editeur de texte style Word //
// Logiciel utilis : Borland Delphi 2005    //
// Packages : JCL 1.95 et JVCL 3.0           //
// Copyright : OpenSource                    //
// Email : lalilo_king@msn.com               //
///////////////////////////////////////////////

unit version;

interface

// Dclaration des variables utilises...

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Unit1, JvExControls, JvComponent, JvArrowButton, JvSpeedbar,
  ExtCtrls, JvExExtCtrls, JvOutlookBar, JvLookOut, JvRollOut, ComCtrls,
  JvExComCtrls, JvComCtrls, JvZoom, JvClock, JvNavigationPane, JvPageList,
  JvProgressBar, JvXPProgressBar, JvTFManager, JvTFDays, XPMan, JvComputerInfoEx,
  JvWizard, JvWizardRouteMapList, JvWizardRouteMapNodes, JvWizardRouteMapSteps,
  JvXPCore, JvXPButtons, JvCSVBaseControls, JvSimScope, JvSimLogic, Grids,
  JvYearGrid, JvMarkupViewer, JvDialogs, StdCtrls, JvExStdCtrls, JvRichEdit,
  JvDice, JvFullColorSpaces, JvFullColorCtrls, JvSplitter, JvNetscapeSplitter,
  JvSlider, ToolWin, JvExForms, JvScrollPanel, JvListView, JvBehaviorLabel,
  JvTabBar, JvWaitingProgress, JvSpecialProgress, JvButton, JvCtrls, JvFooter,
  JvSwitch, JvTransparentButton, JvAnimTitle, JvFormWallpaper, JvAppStorage,
  Menus, JvMenus, JvBaseDlg, JvJVCLAboutForm, JvFormTransparent, JvXPBar,
  ImgList, ActnList, StdActns, jpeg, JvFormAnimation, JvFormAutoSize,
  JvScrollMax, JvEditorCommon, JvEditor, JvProgressComponent, OleCtnrs,
  JvHLEditorPropertyForm, JvUnicodeEditor, JvUnicodeHLEditor;

// Dclaration des nom des champs de la fentre...

type
  TForm1 = class(TForm)
    JvMainMenu1: TJvMainMenu;
    Fichier1: TMenuItem;
    Edition1: TMenuItem;
    Outils1: TMenuItem;
    N1: TMenuItem;
    Ouvrirundocument1: TMenuItem;
    Enregistrer1: TMenuItem;
    EnregistrerSous1: TMenuItem;
    N2: TMenuItem;
    Imprimer1: TMenuItem;
    N3: TMenuItem;
    Quitter1: TMenuItem;
    Annuler1: TMenuItem;
    N4: TMenuItem;
    Copier1: TMenuItem;
    Coller1: TMenuItem;
    Supprimer1: TMenuItem;
    N5: TMenuItem;
    Slectionnertout1: TMenuItem;
    Format1: TMenuItem;
    Syntax1: TMenuItem;
    Options1: TMenuItem;
    Aide1: TMenuItem;
    InformationsPC1: TMenuItem;
    InfosCPU1: TMenuItem;
    InfosMmoire1: TMenuItem;
    About1: TMenuItem;
    JvXPMenuItemPainter1: TJvXPMenuItemPainter;
    Editor: TRichEdit;
    XPManifest1: TXPManifest;
    StandardToolBar: TToolBar;
    ToolButton1: TToolButton;
    OpenButton: TToolButton;
    SaveButton: TToolButton;
    PrintButton: TToolButton;
    ToolButton5: TToolButton;
    CutButton: TToolButton;
    CopyButton: TToolButton;
    PasteButton: TToolButton;
    UndoButton: TToolButton;
    ToolButton10: TToolButton;
    FontName: TComboBox;
    ToolButton11: TToolButton;
    FontSize: TEdit;
    UpDown1: TUpDown;
    ToolButton2: TToolButton;
    BoldButton: TToolButton;
    ItalicButton: TToolButton;
    UnderlineButton: TToolButton;
    ToolButton16: TToolButton;
    LeftAlign: TToolButton;
    CenterAlign: TToolButton;
    RightAlign: TToolButton;
    ToolButton20: TToolButton;
    BulletsButton: TToolButton;
    Bevel1: TBevel;
    StatusBar: TStatusBar;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PrintDialog1: TPrintDialog;
    ActionList1: TActionList;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    EditSelectAll1: TEditSelectAll;
    EditUndo1: TEditUndo;
    EditDelete1: TEditDelete;
    FontDialog1: TFontDialog;
    NouveauDocument2: TMenuItem;
    JvAnimTitle1: TJvAnimTitle;
    JvPopupMenu1: TJvPopupMenu;
    Annuler2: TMenuItem;
    N6: TMenuItem;
    Copier2: TMenuItem;
    Coller2: TMenuItem;
    Supprimer2: TMenuItem;
    N7: TMenuItem;
    outslectionner1: TMenuItem;
    N8: TMenuItem;
    SearchFind1: TSearchFind;
    SearchReplace1: TSearchReplace;
    Recherche1: TMenuItem;
    Chercher1: TMenuItem;
    Remplacer1: TMenuItem;
    SearchFindNext1: TSearchFindNext;
    SearchFindFirst1: TSearchFindFirst;
    Rechercherpremireoccurrence1: TMenuItem;
    Occurrencesuivante1: TMenuItem;
    actSyntax: TAction;
    ImageMenu: TImageList;
    DateetHeure3: TMenuItem;
    procedure DateetHeure1Click(Sender: TObject);

    // Procdure de cration des champs...

    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure actSaveAsClick(Sender: TObject);
    procedure actSaveClick(Sender: TObject);
    procedure actOpenClick(Sender: TObject);
    procedure actNewClick(Sender: TObject);
    procedure actExitClick(Sender: TObject);
    procedure actPrintClick(Sender: TObject);
    procedure BoldButtonClick(Sender: TObject);
    procedure ItalicButtonClick(Sender: TObject);
    procedure UnderlineButtonClick(Sender: TObject);
    procedure AlignButtonClick(Sender: TObject);
    procedure BulletsButtonClick(Sender: TObject);
    procedure FontNameChange(Sender: TObject);
    procedure FontSizeChange(Sender: TObject);
    procedure SelectFont(Sender: TObject);
    procedure SelectionChange(Sender: TObject);
    procedure actAboutClick(sender: TObject);
    procedure actCPUClick(sender: TObject);
    procedure actMemoireClick(sender: TObject);

// Dclaration des fonctions prives...

  private
    FFileName: string;
    FUpdating: Boolean;
    procedure GetFontNames;
    function CurrText: TTextAttributes;
  end;

var
  Form1: TForm1;

function IsPrevInstance: HWND;

implementation

uses RichEdit, ShellAPI, About, infoscpu, memoire;

resourcestring
  sSaveChanges = 'Sauvegarder les changements %s?';
  sOverWrite = 'Voulez vous craser le fichier %s';
  sUntitled = 'Sans Nom...';
  sModified = 'Modifier';
  sColRowInfo = 'Ligne: %3d   Col: %3d';

{$R *.dfm}

// Dclaration des fonctions...

function IsPrevInstance: HWND;
var
  ClassName: array[0..255] of Char;
  Title: string;
begin
  Title:= Application.Title;
  Application.Title:= ''; // On change le titre, car on trouverait toujours une application lance, (la notre).
  try
    GetClassName(Application.Handle, ClassName, 255); // Met dans ClassName le nom de la Class de l'application.
    Result:= FindWindow(ClassName,PChar(Title)); // Renvoie le Handle de la 1re fentre de Class (Type) ClassName, et le titre de l'application.
  finally
    Application.Title:= Title; // Restauration du vrai titre.
  end;
end;

procedure TForm1.SelectionChange(Sender: TObject);
begin
  with Editor.Paragraph do
  try
    FUpdating := True;
    BoldButton.Down := fsBold in Editor.SelAttributes.Style;
    ItalicButton.Down := fsItalic in Editor.SelAttributes.Style;
    UnderlineButton.Down := fsUnderline in Editor.SelAttributes.Style;
    BulletsButton.Down := Boolean(Numbering);
    FontSize.Text := IntToStr(Editor.SelAttributes.Size);
    FontName.Text := Editor.SelAttributes.Name;
    case Ord(Alignment) of
      0: LeftAlign.Down := True;
      1: RightAlign.Down := True;
      2: CenterAlign.Down := True;
    end;
  finally
    FUpdating := False;
  end;
end;

function TForm1.CurrText: TTextAttributes;
begin
  if Editor.SelLength > 0 then Result := Editor.SelAttributes
  else Result := Editor.DefAttributes;
end;

function EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
begin
  TStrings(Data).Add(LogFont.lfFaceName);
  Result := 1;
end;

procedure TForm1.GetFontNames;
var
  DC: HDC;
begin
  DC := GetDC(0);
  EnumFonts(DC, nil, @EnumFontsProc, Pointer(FontName.Items));
  ReleaseDC(0, DC);
  FontName.Sorted := True;
end;

procedure TForm1.actNewClick(Sender: TObject);
begin
  Editor.Lines.Clear;
end;


procedure TForm1.actOpenClick(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    FFileName := OpenDialog.FileName;
    Editor.Lines.LoadFromFile(FFileName);
  end;
end;

procedure TForm1.actSaveClick(Sender: TObject);
begin
  if FFileName <> EmptyStr then
  begin
    Editor.Lines.SaveToFile(FFileName);
    end
  else actSaveAsClick(Sender);
end;

procedure TForm1.actSaveAsClick(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    FFileName := SaveDialog.FileName;
    actSaveClick(Sender);
  end;
end;

procedure TForm1.actExitClick(Sender: TObject);
begin
if MessageDlg ('Etes-vous sur de vouloir quitter ?', mtConfirmation, [mbyes, mbNo], 0) = mrYes
then begin close; end;
end;

procedure TForm1.actPrintClick(Sender: TObject);
begin
  if PrintDialog1.Execute then
    Editor.Print(FFileName);
end;

procedure TForm1.BoldButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if BoldButton.Down then
    CurrText.Style := CurrText.Style + [fsBold]
  else
    CurrText.Style := CurrText.Style - [fsBold];
end;

procedure TForm1.ItalicButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if ItalicButton.Down then
    CurrText.Style := CurrText.Style + [fsItalic]
  else
    CurrText.Style := CurrText.Style - [fsItalic];
end;

procedure TForm1.UnderlineButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if UnderlineButton.Down then
    CurrText.Style := CurrText.Style + [fsUnderline]
  else
    CurrText.Style := CurrText.Style - [fsUnderline];
end;

procedure TForm1.AlignButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  Editor.Paragraph.Alignment := TAlignment(TControl(Sender).Tag);
end;

procedure TForm1.BulletsButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  Editor.Paragraph.Numbering := TNumberingStyle(BulletsButton.Down);
end;

procedure TForm1.FontNameChange(Sender: TObject);
begin
  if FUpdating then Exit;
  CurrText.Name := FontName.Items[FontName.ItemIndex];
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Application.OnHint := ShowHint;
GetFontNames;
SelectionChange(Self);
end;

procedure TForm1.FontSizeChange(Sender: TObject);
begin
  if FUpdating then Exit;
  CurrText.Size := StrToInt(FontSize.Text);
end;

procedure TForm1.SelectFont(Sender: TObject);
begin
  FontDialog1.Font.Assign(Editor.SelAttributes);
  if FontDialog1.Execute then
    CurrText.Assign(FontDialog1.Font);
  SelectionChange(Self);
  Editor.SetFocus;
end;

procedure TForm1.ShowHint(Sender: TObject);
begin
  if Length(Application.Hint) > 0 then
  begin
    StatusBar.SimplePanel := True;
    StatusBar.SimpleText := Application.Hint;
  end
  else StatusBar.SimplePanel := False;
end;

procedure TForm1.actAboutClick(sender: TObject);
begin
frmAbout.ShowModal;
end;

procedure TForm1.actCPUClick(sender: TObject);
begin
frmCpu.ShowModal;
end;

procedure TForm1.actMemoireClick(sender: TObject);
begin
frmMemoire.ShowModal;
end;

procedure TForm1.DateetHeure1Click(Sender: TObject);
begin
Form1.Editor.Text:=DateTimeToStr(Now);
end;

// Fin de la cration de la fentre...

end.
