unit memoire;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TfrmMemoire = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lUtilisee: TLabel;
    lPhysique: TLabel;
    lVirtuelle: TLabel;
    Label4: TLabel;
    lPaginee: TLabel;
    BitBtn1: TBitBtn;
  procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  frmMemoire: TfrmMemoire;

implementation

{$R *.dfm}

procedure TfrmMemoire.Button1Click(Sender: TObject);
var Mem:TMemoryStatus;
Begin
  // Recherche des informations sur la mmoire
  Mem.dwLength:=SizeOf(TMemoryStatus);
  GlobalMemoryStatus(Mem);

  // Affichage des rsultats
  lUtilisee .Caption := IntToStr(Mem.dwMemoryLoad)+' %';
  lPhysique .Caption := FloatToStrF(Mem.dwAvailPhys     /1024/1024,ffFixed,5,1)
                +' / '+ FloatToStrF(Mem.dwTotalPhys     /1024/1024,ffFixed,5,1)+' Mo';
  lPaginee  .Caption := FloatToStrF(Mem.dwAvailPageFile /1024/1024,ffFixed,5,1)
                +' / '+ FloatToStrF(Mem.dwTotalPageFile /1024/1024,ffFixed,5,1)+' Mo';
  lVirtuelle.Caption := FloatToStrF(Mem.dwAvailVirtual  /1024/1024,ffFixed,5,1)
                +' / '+ FloatToStrF(Mem.dwTotalVirtual  /1024/1024,ffFixed,5,1)+' Mo';
end;

end.
